// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VruHighFrequencyContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_HIGH_FREQUENCY_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_HIGH_FREQUENCY_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'heading'
// Member 'orientation'
#include "etsi_its_vam_ts_msgs/msg/detail/wgs84_angle__struct.hpp"
// Member 'speed'
#include "etsi_its_vam_ts_msgs/msg/detail/speed__struct.hpp"
// Member 'longitudinal_acceleration'
#include "etsi_its_vam_ts_msgs/msg/detail/longitudinal_acceleration__struct.hpp"
// Member 'curvature'
#include "etsi_its_vam_ts_msgs/msg/detail/curvature__struct.hpp"
// Member 'curvature_calculation_mode'
#include "etsi_its_vam_ts_msgs/msg/detail/curvature_calculation_mode__struct.hpp"
// Member 'yaw_rate'
#include "etsi_its_vam_ts_msgs/msg/detail/yaw_rate__struct.hpp"
// Member 'lateral_acceleration'
#include "etsi_its_vam_ts_msgs/msg/detail/lateral_acceleration__struct.hpp"
// Member 'vertical_acceleration'
#include "etsi_its_vam_ts_msgs/msg/detail/vertical_acceleration__struct.hpp"
// Member 'vru_lane_position'
#include "etsi_its_vam_ts_msgs/msg/detail/generalized_lane_position__struct.hpp"
// Member 'environment'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_environment__struct.hpp"
// Member 'movement_control'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_movement_control__struct.hpp"
// Member 'roll_angle'
#include "etsi_its_vam_ts_msgs/msg/detail/cartesian_angle__struct.hpp"
// Member 'device_usage'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_device_usage__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VruHighFrequencyContainer_
{
  using Type = VruHighFrequencyContainer_<ContainerAllocator>;

  explicit VruHighFrequencyContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : heading(_init),
    speed(_init),
    longitudinal_acceleration(_init),
    curvature(_init),
    curvature_calculation_mode(_init),
    yaw_rate(_init),
    lateral_acceleration(_init),
    vertical_acceleration(_init),
    vru_lane_position(_init),
    environment(_init),
    movement_control(_init),
    orientation(_init),
    roll_angle(_init),
    device_usage(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->curvature_is_present = false;
      this->curvature_calculation_mode_is_present = false;
      this->yaw_rate_is_present = false;
      this->lateral_acceleration_is_present = false;
      this->vertical_acceleration_is_present = false;
      this->vru_lane_position_is_present = false;
      this->environment_is_present = false;
      this->movement_control_is_present = false;
      this->orientation_is_present = false;
      this->roll_angle_is_present = false;
      this->device_usage_is_present = false;
    }
  }

  explicit VruHighFrequencyContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : heading(_alloc, _init),
    speed(_alloc, _init),
    longitudinal_acceleration(_alloc, _init),
    curvature(_alloc, _init),
    curvature_calculation_mode(_alloc, _init),
    yaw_rate(_alloc, _init),
    lateral_acceleration(_alloc, _init),
    vertical_acceleration(_alloc, _init),
    vru_lane_position(_alloc, _init),
    environment(_alloc, _init),
    movement_control(_alloc, _init),
    orientation(_alloc, _init),
    roll_angle(_alloc, _init),
    device_usage(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->curvature_is_present = false;
      this->curvature_calculation_mode_is_present = false;
      this->yaw_rate_is_present = false;
      this->lateral_acceleration_is_present = false;
      this->vertical_acceleration_is_present = false;
      this->vru_lane_position_is_present = false;
      this->environment_is_present = false;
      this->movement_control_is_present = false;
      this->orientation_is_present = false;
      this->roll_angle_is_present = false;
      this->device_usage_is_present = false;
    }
  }

  // field types and members
  using _heading_type =
    etsi_its_vam_ts_msgs::msg::Wgs84Angle_<ContainerAllocator>;
  _heading_type heading;
  using _speed_type =
    etsi_its_vam_ts_msgs::msg::Speed_<ContainerAllocator>;
  _speed_type speed;
  using _longitudinal_acceleration_type =
    etsi_its_vam_ts_msgs::msg::LongitudinalAcceleration_<ContainerAllocator>;
  _longitudinal_acceleration_type longitudinal_acceleration;
  using _curvature_type =
    etsi_its_vam_ts_msgs::msg::Curvature_<ContainerAllocator>;
  _curvature_type curvature;
  using _curvature_is_present_type =
    bool;
  _curvature_is_present_type curvature_is_present;
  using _curvature_calculation_mode_type =
    etsi_its_vam_ts_msgs::msg::CurvatureCalculationMode_<ContainerAllocator>;
  _curvature_calculation_mode_type curvature_calculation_mode;
  using _curvature_calculation_mode_is_present_type =
    bool;
  _curvature_calculation_mode_is_present_type curvature_calculation_mode_is_present;
  using _yaw_rate_type =
    etsi_its_vam_ts_msgs::msg::YawRate_<ContainerAllocator>;
  _yaw_rate_type yaw_rate;
  using _yaw_rate_is_present_type =
    bool;
  _yaw_rate_is_present_type yaw_rate_is_present;
  using _lateral_acceleration_type =
    etsi_its_vam_ts_msgs::msg::LateralAcceleration_<ContainerAllocator>;
  _lateral_acceleration_type lateral_acceleration;
  using _lateral_acceleration_is_present_type =
    bool;
  _lateral_acceleration_is_present_type lateral_acceleration_is_present;
  using _vertical_acceleration_type =
    etsi_its_vam_ts_msgs::msg::VerticalAcceleration_<ContainerAllocator>;
  _vertical_acceleration_type vertical_acceleration;
  using _vertical_acceleration_is_present_type =
    bool;
  _vertical_acceleration_is_present_type vertical_acceleration_is_present;
  using _vru_lane_position_type =
    etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>;
  _vru_lane_position_type vru_lane_position;
  using _vru_lane_position_is_present_type =
    bool;
  _vru_lane_position_is_present_type vru_lane_position_is_present;
  using _environment_type =
    etsi_its_vam_ts_msgs::msg::VruEnvironment_<ContainerAllocator>;
  _environment_type environment;
  using _environment_is_present_type =
    bool;
  _environment_is_present_type environment_is_present;
  using _movement_control_type =
    etsi_its_vam_ts_msgs::msg::VruMovementControl_<ContainerAllocator>;
  _movement_control_type movement_control;
  using _movement_control_is_present_type =
    bool;
  _movement_control_is_present_type movement_control_is_present;
  using _orientation_type =
    etsi_its_vam_ts_msgs::msg::Wgs84Angle_<ContainerAllocator>;
  _orientation_type orientation;
  using _orientation_is_present_type =
    bool;
  _orientation_is_present_type orientation_is_present;
  using _roll_angle_type =
    etsi_its_vam_ts_msgs::msg::CartesianAngle_<ContainerAllocator>;
  _roll_angle_type roll_angle;
  using _roll_angle_is_present_type =
    bool;
  _roll_angle_is_present_type roll_angle_is_present;
  using _device_usage_type =
    etsi_its_vam_ts_msgs::msg::VruDeviceUsage_<ContainerAllocator>;
  _device_usage_type device_usage;
  using _device_usage_is_present_type =
    bool;
  _device_usage_is_present_type device_usage_is_present;

  // setters for named parameter idiom
  Type & set__heading(
    const etsi_its_vam_ts_msgs::msg::Wgs84Angle_<ContainerAllocator> & _arg)
  {
    this->heading = _arg;
    return *this;
  }
  Type & set__speed(
    const etsi_its_vam_ts_msgs::msg::Speed_<ContainerAllocator> & _arg)
  {
    this->speed = _arg;
    return *this;
  }
  Type & set__longitudinal_acceleration(
    const etsi_its_vam_ts_msgs::msg::LongitudinalAcceleration_<ContainerAllocator> & _arg)
  {
    this->longitudinal_acceleration = _arg;
    return *this;
  }
  Type & set__curvature(
    const etsi_its_vam_ts_msgs::msg::Curvature_<ContainerAllocator> & _arg)
  {
    this->curvature = _arg;
    return *this;
  }
  Type & set__curvature_is_present(
    const bool & _arg)
  {
    this->curvature_is_present = _arg;
    return *this;
  }
  Type & set__curvature_calculation_mode(
    const etsi_its_vam_ts_msgs::msg::CurvatureCalculationMode_<ContainerAllocator> & _arg)
  {
    this->curvature_calculation_mode = _arg;
    return *this;
  }
  Type & set__curvature_calculation_mode_is_present(
    const bool & _arg)
  {
    this->curvature_calculation_mode_is_present = _arg;
    return *this;
  }
  Type & set__yaw_rate(
    const etsi_its_vam_ts_msgs::msg::YawRate_<ContainerAllocator> & _arg)
  {
    this->yaw_rate = _arg;
    return *this;
  }
  Type & set__yaw_rate_is_present(
    const bool & _arg)
  {
    this->yaw_rate_is_present = _arg;
    return *this;
  }
  Type & set__lateral_acceleration(
    const etsi_its_vam_ts_msgs::msg::LateralAcceleration_<ContainerAllocator> & _arg)
  {
    this->lateral_acceleration = _arg;
    return *this;
  }
  Type & set__lateral_acceleration_is_present(
    const bool & _arg)
  {
    this->lateral_acceleration_is_present = _arg;
    return *this;
  }
  Type & set__vertical_acceleration(
    const etsi_its_vam_ts_msgs::msg::VerticalAcceleration_<ContainerAllocator> & _arg)
  {
    this->vertical_acceleration = _arg;
    return *this;
  }
  Type & set__vertical_acceleration_is_present(
    const bool & _arg)
  {
    this->vertical_acceleration_is_present = _arg;
    return *this;
  }
  Type & set__vru_lane_position(
    const etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> & _arg)
  {
    this->vru_lane_position = _arg;
    return *this;
  }
  Type & set__vru_lane_position_is_present(
    const bool & _arg)
  {
    this->vru_lane_position_is_present = _arg;
    return *this;
  }
  Type & set__environment(
    const etsi_its_vam_ts_msgs::msg::VruEnvironment_<ContainerAllocator> & _arg)
  {
    this->environment = _arg;
    return *this;
  }
  Type & set__environment_is_present(
    const bool & _arg)
  {
    this->environment_is_present = _arg;
    return *this;
  }
  Type & set__movement_control(
    const etsi_its_vam_ts_msgs::msg::VruMovementControl_<ContainerAllocator> & _arg)
  {
    this->movement_control = _arg;
    return *this;
  }
  Type & set__movement_control_is_present(
    const bool & _arg)
  {
    this->movement_control_is_present = _arg;
    return *this;
  }
  Type & set__orientation(
    const etsi_its_vam_ts_msgs::msg::Wgs84Angle_<ContainerAllocator> & _arg)
  {
    this->orientation = _arg;
    return *this;
  }
  Type & set__orientation_is_present(
    const bool & _arg)
  {
    this->orientation_is_present = _arg;
    return *this;
  }
  Type & set__roll_angle(
    const etsi_its_vam_ts_msgs::msg::CartesianAngle_<ContainerAllocator> & _arg)
  {
    this->roll_angle = _arg;
    return *this;
  }
  Type & set__roll_angle_is_present(
    const bool & _arg)
  {
    this->roll_angle_is_present = _arg;
    return *this;
  }
  Type & set__device_usage(
    const etsi_its_vam_ts_msgs::msg::VruDeviceUsage_<ContainerAllocator> & _arg)
  {
    this->device_usage = _arg;
    return *this;
  }
  Type & set__device_usage_is_present(
    const bool & _arg)
  {
    this->device_usage_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VruHighFrequencyContainer_ & other) const
  {
    if (this->heading != other.heading) {
      return false;
    }
    if (this->speed != other.speed) {
      return false;
    }
    if (this->longitudinal_acceleration != other.longitudinal_acceleration) {
      return false;
    }
    if (this->curvature != other.curvature) {
      return false;
    }
    if (this->curvature_is_present != other.curvature_is_present) {
      return false;
    }
    if (this->curvature_calculation_mode != other.curvature_calculation_mode) {
      return false;
    }
    if (this->curvature_calculation_mode_is_present != other.curvature_calculation_mode_is_present) {
      return false;
    }
    if (this->yaw_rate != other.yaw_rate) {
      return false;
    }
    if (this->yaw_rate_is_present != other.yaw_rate_is_present) {
      return false;
    }
    if (this->lateral_acceleration != other.lateral_acceleration) {
      return false;
    }
    if (this->lateral_acceleration_is_present != other.lateral_acceleration_is_present) {
      return false;
    }
    if (this->vertical_acceleration != other.vertical_acceleration) {
      return false;
    }
    if (this->vertical_acceleration_is_present != other.vertical_acceleration_is_present) {
      return false;
    }
    if (this->vru_lane_position != other.vru_lane_position) {
      return false;
    }
    if (this->vru_lane_position_is_present != other.vru_lane_position_is_present) {
      return false;
    }
    if (this->environment != other.environment) {
      return false;
    }
    if (this->environment_is_present != other.environment_is_present) {
      return false;
    }
    if (this->movement_control != other.movement_control) {
      return false;
    }
    if (this->movement_control_is_present != other.movement_control_is_present) {
      return false;
    }
    if (this->orientation != other.orientation) {
      return false;
    }
    if (this->orientation_is_present != other.orientation_is_present) {
      return false;
    }
    if (this->roll_angle != other.roll_angle) {
      return false;
    }
    if (this->roll_angle_is_present != other.roll_angle_is_present) {
      return false;
    }
    if (this->device_usage != other.device_usage) {
      return false;
    }
    if (this->device_usage_is_present != other.device_usage_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const VruHighFrequencyContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VruHighFrequencyContainer_

// alias to use template instance with default allocator
using VruHighFrequencyContainer =
  etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_HIGH_FREQUENCY_CONTAINER__STRUCT_HPP_
